Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PowerProfile.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PowerProfile.java	(revision 1167)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PowerProfile.java	(revision 1207)
@@ -24,9 +24,10 @@
 	public PowerProfile(EnergyEstimationPlugin energyEstimationPlugin, List<PowerState> powerStates) {
 		this.energyEstimationPlugin = energyEstimationPlugin;
+		this.supportedPowerStates = powerStates;
 		this.powerUsage = new ArrayList<PowerUsage>();
-		this.supportedPowerStates = powerStates;
+		initDefaultPowerStates();
 	}
 	
-	public PowerProfile(EnergyEstimationPlugin energyEstimationPlugin, List<PowerState> powerStates,  List<PState> pStates) {
+	public PowerProfile(EnergyEstimationPlugin energyEstimationPlugin, List<PowerState> powerStates, List<PState> pStates) {
 		this.energyEstimationPlugin = energyEstimationPlugin;
 		this.supportedPowerStates = powerStates;
@@ -37,4 +38,5 @@
 			supportedPStates.put(pState.getName(), pState);
 		}
+		initDefaultPowerStates();
 	}
 	
@@ -60,7 +62,7 @@
 	}
 	
-	public List<PowerState> getSupportedPowerStates() throws NoSuchFieldException{
+	public List<PowerState> getSupportedPowerStates() {
 		if(supportedPowerStates == null)
-			throw new NoSuchFieldException("Supported power states are not defined.");
+			return new ArrayList<PowerState>();
 		return supportedPowerStates;
 	}
@@ -111,4 +113,24 @@
 	}
 
-
+	protected void initDefaultPowerStates(){
+		boolean supportsON = false;
+		boolean supportsOFF = false;
+		if(supportedPowerStates == null){
+			supportedPowerStates = new ArrayList<PowerState>();
+		}
+		for(PowerState ps: supportedPowerStates){
+			if(ps.getName().equals(StandardPowerStateName.ON)){
+				supportsON = true;
+			} else if (ps.getName().equals(StandardPowerStateName.OFF)){
+				supportsOFF = true;
+			}
+		}
+		
+		if(!supportsON){
+			supportedPowerStates.add(new PowerState(StandardPowerStateName.ON, -1, new ArrayList<Transition>()));
+		}
+		if(!supportsOFF){
+			supportedPowerStates.add(new PowerState(StandardPowerStateName.OFF, -1, new ArrayList<Transition>()));
+		}
+	}
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/DataCenterPowerInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/DataCenterPowerInterface.java	(revision 495)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/DataCenterPowerInterface.java	(revision 1207)
@@ -1,4 +1,7 @@
 package schedframe.resources.computing.profiles.energy.power.ui;
 
+import org.joda.time.DateTime;
+
+import schedframe.SimulatedEnvironment;
 import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.DataCenter;
@@ -23,5 +26,5 @@
 			child.getPowerInterface().setPowerState(state);
 		}
-
+		//ResourceController.traceResource(new DateTime().getMillis(), resource.getFullName(), "POWER_STATE_CHANGED", state.getName());
 		return true;
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ComputingNodePowerInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ComputingNodePowerInterface.java	(revision 1166)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ComputingNodePowerInterface.java	(revision 1207)
@@ -1,4 +1,9 @@
 package schedframe.resources.computing.profiles.energy.power.ui;
 
+
+
+import org.joda.time.DateTime;
+
+import schedframe.SimulatedEnvironment;
 import schedframe.resources.ResourceStatus;
 import schedframe.resources.computing.ComputingNode;
@@ -38,5 +43,5 @@
 		
 		if(!pePowerStateChangeStatus){
-			computingNode.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, computingNode.getName()));
+			computingNode.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, computingNode.getFullName()));
 		}
 
@@ -48,4 +53,5 @@
 		}
 		//computingNode.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, computingNode.getName()));
+		//ResourceController.traceResource(new DateTime().getMillis(), resource.getFullName(), "POWER_STATE_CHANGED", state.getName());
 		return true;
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ComputingResourcePowerInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ComputingResourcePowerInterface.java	(revision 579)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ComputingResourcePowerInterface.java	(revision 1207)
@@ -4,7 +4,9 @@
 import java.util.List;
 
+import org.joda.time.DateTime;
 import org.joda.time.DateTimeUtils;
 
 import schedframe.Parameters;
+import schedframe.SimulatedEnvironment;
 import schedframe.resources.ResourceStatus;
 import schedframe.resources.computing.ComputingResource;
@@ -46,9 +48,10 @@
 			}
 			//notifications from all levels
-			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getName()));
+			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getFullName()));
 
 			//notification from last level
 			//if (resource.getChildren() == null) resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource));
 			
+			//ResourceController.traceResource(new DateTime().getMillis(), resource.getFullName(), "POWER_STATE_CHANGED", state.getName());
 			return true;
 		}
@@ -70,12 +73,8 @@
 
 	public boolean supportPowerState(PowerStateName state) {
-		try {
-			for(PowerState powerState: powerProfile.getSupportedPowerStates()){
-				if(powerState.getName().equals(state)){
-					return true;
-				}
+		for(PowerState powerState: powerProfile.getSupportedPowerStates()){
+			if(powerState.getName().equals(state)){
+				return true;
 			}
-		} catch (NoSuchFieldException e) {
-			return false;
 		}
 		return false;
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ProcessorPowerInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ProcessorPowerInterface.java	(revision 782)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ProcessorPowerInterface.java	(revision 1207)
@@ -4,4 +4,7 @@
 import java.util.Map;
 
+import org.joda.time.DateTime;
+
+import schedframe.SimulatedEnvironment;
 import schedframe.resources.ResourceStatus;
 import schedframe.resources.computing.ComputingResource;
@@ -16,5 +19,4 @@
 
 	protected PState currentPState;
-
 
 	public ProcessorPowerInterface(ComputingResource resource, PowerProfile pp){
@@ -34,5 +36,5 @@
 				resource.setStatus(ResourceStatus.FREE);
 			}
-			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getName()));		
+			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getFullName()));		
 		}
 
@@ -68,6 +70,8 @@
 			//speed.setAmount(Double.valueOf(currentPState.getFrequency()).intValue());
 			//new ResourceEventCommand(resource).execute(EnergyEventType.FREQUENCY_CHANGED);
-			resource.handleEvent(new EnergyEvent(EnergyEventType.FREQUENCY_CHANGED, resource.getName()));
+			resource.handleEvent(new EnergyEvent(EnergyEventType.FREQUENCY_CHANGED, resource.getFullName()));
 			//resource.getScheduler().sendInternal(GridSimTags.SCHEDULE_NOW, DCWormsTags.UPDATE, resource.getName());
+			
+			//ResourceController.traceResource(new DateTime().getMillis(), resource.getFullName(), "PSTATE_CHANGED", pStateName);
 			return true;
 		}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/plugin/EnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/plugin/EnergyEstimationPlugin.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/plugin/EnergyEstimationPlugin.java	(revision 1207)
@@ -2,15 +2,15 @@
 
 import schedframe.Plugin;
-import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
 
 public interface EnergyEstimationPlugin extends Plugin {
 	
-	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry, ComputingResource resource);
+	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource);
 
-	public double estimateAirThroughput(EnergyEvent event, JobRegistry jobRegistry, ComputingResource resource);
+	public double estimateAirThroughput(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource);
 
-	public double estimateTemperature(EnergyEvent event, JobRegistry jobRegistry, ComputingResource resource);
+	public double estimateTemperature(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource);
 
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/thermal/ThermalInterfaceFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/thermal/ThermalInterfaceFactory.java	(revision 803)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/thermal/ThermalInterfaceFactory.java	(revision 1207)
@@ -1,14 +1,22 @@
 package schedframe.resources.computing.profiles.energy.thermal;
 
+import schedframe.resources.StandardResourceType;
 import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.profiles.energy.thermal.ui.ComputingResourceThermalInterface;
 import schedframe.resources.computing.profiles.energy.thermal.ui.ThermalInterface;
+import schedframe.resources.devices.PhysicalResource;
+import schedframe.resources.devices.PhysicalResourceThermalInterface;
 
 public class ThermalInterfaceFactory {
-	public static ThermalInterface createThermalInterface(ComputingResource resource, ThermalProfile tp){
+	public static ThermalInterface createThermalInterface(PhysicalResource resource, ThermalProfile tp){
 		if(tp == null)
 			return null;
-		ThermalInterface thermalInterface = new ComputingResourceThermalInterface(resource, tp);
-
+		ThermalInterface thermalInterface;
+		if (resource.getType().getName().equals(StandardResourceType.CRAH.getName()))
+			thermalInterface = new PhysicalResourceThermalInterface(resource, tp);
+		else if (resource.getType().getName().equals(StandardResourceType.Fan.getName()))
+			thermalInterface = new PhysicalResourceThermalInterface(resource, tp);
+		else 
+			thermalInterface = new ComputingResourceThermalInterface((ComputingResource)resource, tp);
 		return thermalInterface;
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirThroughputProfile.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirThroughputProfile.java	(revision 495)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirThroughputProfile.java	(revision 1207)
@@ -28,5 +28,5 @@
 	}
 	
-	public void addToPowerUsageHistory(double airFlow) {
+	public void addToAirFlowHistory(double airFlow) {
 
 		if (airFlowHistory.size() == 0) {
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/StandardAirThroughputStateName.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/StandardAirThroughputStateName.java	(revision 753)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/StandardAirThroughputStateName.java	(revision 1207)
@@ -3,6 +3,6 @@
 public enum  StandardAirThroughputStateName implements AirThroughputStateName{
 
-	FAN_ON,
-	FAN_OFF;
+	ON,
+	OFF;
 
 	public String getName() {
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/ComputingResourceAirThroughputInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/ComputingResourceAirThroughputInterface.java	(revision 754)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/ComputingResourceAirThroughputInterface.java	(revision 1207)
@@ -4,8 +4,11 @@
 import java.util.List;
 
+import org.joda.time.DateTimeUtils;
+
 import schedframe.Parameters;
 import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
 import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirFlowValue;
 import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputProfile;
 import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputState;
@@ -22,5 +25,5 @@
 		this.resource = resource;
 		this.airThroughputProfile = airThroughputProfile;
-		this.currentAirThroughputState = StandardAirThroughputStateName.FAN_ON;
+		this.currentAirThroughputState = StandardAirThroughputStateName.ON;
 	}
 	
@@ -34,5 +37,6 @@
 			
 			//TO DO - notifications should be called for all resources starting form the lowest layer
-			resource.handleEvent(new EnergyEvent(EnergyEventType.AIRFLOW_STATE_CHANGED, resource.getName()));
+			resource.handleEvent(new EnergyEvent(EnergyEventType.AIRFLOW_STATE_CHANGED, resource.getFullName()));
+			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getFullName()));
 			return true;
 		}
@@ -83,4 +87,23 @@
 	}
 	
+	public AirFlowValue getRecentAirFlow() {
+		AirFlowValue airFlow = null;
+		int lastIdx = getAirFlowHistory().size() - 1;
+		if(lastIdx >= 0)
+			airFlow = getAirFlowHistory().get(lastIdx);
+		else {	
+			try {
+				airFlow = new AirFlowValue(DateTimeUtils.currentTimeMillis(), getAirFlow(currentAirThroughputState));
+			} catch (NoSuchFieldException e) {
+			}
+		}
+		return airFlow;
+	}
+	
+	public List<AirFlowValue> getAirFlowHistory(){
+		return airThroughputProfile.getAirThroughputHistory();
+	}
+	
+	
 	public Parameters getParameters() {
 		return airThroughputProfile.getParameters();
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/AirThroughputInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/AirThroughputInterface.java	(revision 754)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/AirThroughputInterface.java	(revision 1207)
@@ -4,4 +4,5 @@
 
 import schedframe.Parameters;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirFlowValue;
 import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputState;
 import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputStateName;
@@ -9,5 +10,5 @@
 public interface AirThroughputInterface {
 	
-	public AirThroughputStateName  getAirThroughputState();
+	public AirThroughputStateName getAirThroughputState();
 	
 	public boolean setAirThroughputState(AirThroughputStateName airThroughputState);
@@ -21,4 +22,10 @@
 	public double getPowerConsumption(AirThroughputStateName state) throws NoSuchFieldException;
 	
+	public AirFlowValue getRecentAirFlow();
+	
+	List<AirFlowValue> getAirFlowHistory();
+	
 	public Parameters getParameters();
+	
+	
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirThroughputInterfaceFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirThroughputInterfaceFactory.java	(revision 753)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirThroughputInterfaceFactory.java	(revision 1207)
@@ -1,15 +1,30 @@
 package schedframe.resources.computing.profiles.energy.airthroughput;
 
+import schedframe.resources.StandardResourceType;
 import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.profiles.energy.airthroughput.ui.AirThroughputInterface;
 import schedframe.resources.computing.profiles.energy.airthroughput.ui.ComputingResourceAirThroughputInterface;
+import schedframe.resources.devices.PhysicalResource;
+import schedframe.resources.devices.PhysicalResourceAirThroughputInterface;
+import schedframe.resources.devices.coolemall.FanAirThroughputInterface;
 
 public class AirThroughputInterfaceFactory {
 	
-	public static AirThroughputInterface createAirThroughputInterface(ComputingResource resource, AirThroughputProfile atp){
+	public static AirThroughputInterface createAirThroughputInterface(PhysicalResource resource, AirThroughputProfile atp){
 		if(atp == null)
 			return null;
-		AirThroughputInterface airThroughputInterface = new ComputingResourceAirThroughputInterface(resource, atp);
-
+		AirThroughputInterface airThroughputInterface = null;
+		if(resource.getType().getName().equals(StandardResourceType.CRAH.getName()))
+			airThroughputInterface = new PhysicalResourceAirThroughputInterface(resource, atp);
+		else if(resource.getType().getName().equals(StandardResourceType.Fan.getName()))
+			airThroughputInterface = new FanAirThroughputInterface(resource, atp);
+		else if(resource.getType().getName().equals(StandardResourceType.Inlet.getName()))
+			airThroughputInterface = new FanAirThroughputInterface(resource, atp);
+		else if(resource.getType().getName().equals(StandardResourceType.Outlet.getName()))
+			airThroughputInterface = new FanAirThroughputInterface(resource, atp);
+		else if(resource.getType().getName().equals(StandardResourceType.CoolingDevice.getName()))
+			airThroughputInterface = new PhysicalResourceAirThroughputInterface(resource, atp);
+		else
+			airThroughputInterface = new ComputingResourceAirThroughputInterface((ComputingResource)resource, atp);
 		return airThroughputInterface;
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/EnergyExtension.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/EnergyExtension.java	(revision 1165)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/EnergyExtension.java	(revision 1207)
@@ -7,5 +7,4 @@
 
 import schedframe.events.Event;
-import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.extensions.Extension;
 import schedframe.resources.computing.extensions.ExtensionException;
@@ -20,5 +19,7 @@
 import schedframe.resources.computing.profiles.energy.thermal.ThermalProfile;
 import schedframe.resources.computing.profiles.energy.thermal.ui.ThermalInterface;
+import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistryImpl;
+import simulator.DataCenterWorkloadSimulator;
 
 public class EnergyExtension implements Extension{
@@ -35,34 +36,74 @@
 	protected ThermalProfile thermalProfile;
 	
-  	protected ComputingResource computingResource;
-
-
-	public EnergyExtension(ComputingResource computingResource, PowerInterface powerInterface, PowerProfile powerProfile) {
+  	protected PhysicalResource resource;
+
+
+	/*public EnergyExtension(PhysicalResource resource, PowerInterface powerInterface, PowerProfile powerProfile) {
+		super();
+		this.resource = resource;
 		this.powerProfile = powerProfile;
-		this.powerInterface = PowerInterfaceFactory.createPowerInterface(computingResource, powerProfile);
-	}
-	
-	public EnergyExtension(ComputingResource computingResource, PowerProfile powerProfile,
+		this.powerInterface = PowerInterfaceFactory.createPowerInterface(resource, powerProfile);
+	}
+	
+	public EnergyExtension(PhysicalResource resource, PowerProfile powerProfile,
 			AirThroughputProfile airFlowProfile) {
 		super();
-		this.computingResource = computingResource;
+		this.resource = resource;
 		this.powerProfile = powerProfile;
-		this.powerInterface = PowerInterfaceFactory.createPowerInterface(computingResource, powerProfile);
+		this.powerInterface = PowerInterfaceFactory.createPowerInterface(resource, powerProfile);
 		this.airFlowProfile = airFlowProfile;
-		this.airFlowInterface = AirThroughputInterfaceFactory.createAirThroughputInterface(computingResource, airFlowProfile);
-	}
-	
-	public EnergyExtension(ComputingResource computingResource, PowerProfile powerProfile,
+		this.airFlowInterface = AirThroughputInterfaceFactory.createAirThroughputInterface(resource, airFlowProfile);
+	}
+	
+	public EnergyExtension(PhysicalResource resource, PowerProfile powerProfile,
 			AirThroughputProfile airFlowProfile, ThermalProfile thermalProfile) {
 		super();
-		this.computingResource = computingResource;
+		this.resource = resource;
 		this.powerProfile = powerProfile;
-		this.powerInterface = PowerInterfaceFactory.createPowerInterface(computingResource, powerProfile);
+		this.powerInterface = PowerInterfaceFactory.createPowerInterface(resource, powerProfile);
 		this.airFlowProfile = airFlowProfile;
-		this.airFlowInterface = AirThroughputInterfaceFactory.createAirThroughputInterface(computingResource, airFlowProfile);
+		this.airFlowInterface = AirThroughputInterfaceFactory.createAirThroughputInterface(resource, airFlowProfile);
 		this.thermalProfile = thermalProfile;
-		this.thermalInterface = ThermalInterfaceFactory.createThermalInterface(computingResource, thermalProfile);
-	}
-
+		this.thermalInterface = ThermalInterfaceFactory.createThermalInterface(resource, thermalProfile);
+	}*/
+
+	public static class Builder {
+		  
+		protected PhysicalResource resource;
+		protected PowerInterface powerInterface;
+		protected PowerProfile powerProfile;
+		
+		protected AirThroughputInterface airFlowInterface;
+		protected AirThroughputProfile airFlowProfile;
+		
+		protected ThermalInterface thermalInterface;
+		protected ThermalProfile thermalProfile;
+		
+		public Builder resource(PhysicalResource res) {this.resource = res; return this;}
+		
+		public Builder powerProfile(PowerProfile pp){this.powerProfile = pp; this.powerInterface = PowerInterfaceFactory.createPowerInterface(resource, powerProfile); return this; }
+
+        public Builder airFlowProfile(AirThroughputProfile atp){this.airFlowProfile = atp; this.airFlowInterface = AirThroughputInterfaceFactory.createAirThroughputInterface(resource, airFlowProfile); return this; }
+
+        public Builder thermalProfile(ThermalProfile tp){this.thermalProfile = tp; this.thermalInterface = ThermalInterfaceFactory.createThermalInterface(resource, thermalProfile); return this; }
+
+        public EnergyExtension build() {
+            return new EnergyExtension(this);
+        }
+	}
+	
+	private EnergyExtension(Builder builder) {
+		this.resource = builder.resource;
+		this.powerInterface = builder.powerInterface;
+		this.powerProfile = builder.powerProfile;
+		
+		this.airFlowInterface = builder.airFlowInterface ;
+		this.airFlowProfile = builder.airFlowProfile;
+		
+		this.thermalInterface = builder.thermalInterface;
+		this.thermalProfile = builder.thermalProfile;
+	}
+
+	
 	public boolean supportsEvent(Event event) {
 
@@ -82,4 +123,6 @@
 		if(event.getType().getName().equals(EnergyEventType.AIRFLOW_STATE_CHANGED.getName()))
 			return true;
+		if(event.getType().getName().equals(EnergyEventType.TEMPERATURE_CHANGED.getName()))
+			return true;
 		
 		else return false;
@@ -90,10 +133,10 @@
 		EnergyEvent enEvent = (EnergyEvent)event;
 		double power = 0;
-		double temperature = 0;
+		boolean status = false;
 		try{
 			switch (enEvent.getType()) {
 			
 			case POWER_STATE_CHANGED:
-				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
+				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
 				/*if(computingResource instanceof ComputingNode){
 					ComputingNode node = (ComputingNode)computingResource;
@@ -109,45 +152,36 @@
 					}
 				}
-				else*/ powerProfile.addToPowerUsageHistory(power);
-				temperature = powerProfile.getEnergyEstimationPlugin().estimateTemperature(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
-				thermalProfile.addToTemperatureHistory(temperature);
+				else*/ 
+				
+				status = powerProfile.addToPowerUsageHistory(power);
 				break;
 				
 			case FREQUENCY_CHANGED:
-				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
-				powerProfile.addToPowerUsageHistory(power);
-				temperature = powerProfile.getEnergyEstimationPlugin().estimateTemperature(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
-				thermalProfile.addToTemperatureHistory(temperature);
+				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
+				status = powerProfile.addToPowerUsageHistory(power);
 				break;
 				
 			case TASK_STARTED:
-				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
-				powerProfile.addToPowerUsageHistory(power);
-				temperature = powerProfile.getEnergyEstimationPlugin().estimateTemperature(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
-				thermalProfile.addToTemperatureHistory(temperature);
+				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
+				status = powerProfile.addToPowerUsageHistory(power);
 				break;
 	
 			case TASK_FINISHED:
-				//System.out.println(this.resource.getName() + " - ENERGY EXTENSION: TASK FINISHED");
-				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
-				//System.out.println(this.resource.getName() + " - ESTIMATED ENERGY:" + power);
-				powerProfile.addToPowerUsageHistory(power);
-				temperature = powerProfile.getEnergyEstimationPlugin().estimateTemperature(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
-				thermalProfile.addToTemperatureHistory(temperature);
+				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
+				status = powerProfile.addToPowerUsageHistory(power);
 				break;
 				
 			case RESOURCE_UTILIZATION_CHANGED:
-				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
-				powerProfile.addToPowerUsageHistory(power);
-				temperature = powerProfile.getEnergyEstimationPlugin().estimateTemperature(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
-				thermalProfile.addToTemperatureHistory(temperature);
+				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
+				status = powerProfile.addToPowerUsageHistory(power);
 				break;
 				
 			case AIRFLOW_STATE_CHANGED:
-				double airFlow = powerProfile.getEnergyEstimationPlugin().estimateAirThroughput(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
-				airFlowProfile.addToPowerUsageHistory(airFlow);
-				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
-				powerProfile.addToPowerUsageHistory(power);
-				temperature = powerProfile.getEnergyEstimationPlugin().estimateTemperature(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
+				double airFlow = powerProfile.getEnergyEstimationPlugin().estimateAirThroughput(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
+				airFlowProfile.addToAirFlowHistory(airFlow);
+				break;
+				
+			case TEMPERATURE_CHANGED:
+				double temperature = powerProfile.getEnergyEstimationPlugin().estimateTemperature(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
 				thermalProfile.addToTemperatureHistory(temperature);
 				break;
@@ -156,4 +190,7 @@
 			
 		}
+		if(status){
+			DataCenterWorkloadSimulator.getEventManager().sendToResources(resource.getType(), 0, new EnergyEvent(EnergyEventType.TEMPERATURE_CHANGED, resource.getFullName()));
+		}
 	}
 
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/validator/ResourceNameValidator.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/validator/ResourceNameValidator.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/validator/ResourceNameValidator.java	(revision 1207)
@@ -13,5 +13,5 @@
 	@Override
 	public boolean validate(ComputingResource resource) {
-		return resource.getName().equals(name);
+		return resource.getFullName().equals(name);
 	}
 
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/DataCenter.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/DataCenter.java	(revision 756)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/DataCenter.java	(revision 1207)
@@ -20,5 +20,5 @@
 	@SuppressWarnings("unchecked")
 	public List<ComputingNode> getComputingNodes(){
-		return (List<ComputingNode>) getDescendantsByType(StandardResourceType.ComputingNode);
+		return (List<ComputingNode>) getDescendantsByType(StandardResourceType.Node);
 	}
 	
